include<metric.scad>;
include<util.scad>;
include<tile.scad>;

bat_t = 2;
bat_d = 18;
bat_l = 65;
tile_t = bat_t;
con_d = 2;
con_h = 4;

module bat(center = false) color("red")
    cylinder(d = bat_d, h = bat_l, center = center);

module local_tile() difference() {
    hull() tile_pos(T24, tile_t);
    tile_screw_pos(T24) Mscrew_hole(M2L8C);
}
module con_pos() {
    for (i = [ -0.5, 0.5 ], j = [ -0.5, 0.5 ])
        translate(
            [ 0, i * (bat_t + con_d), j * (Ta(T24) - 2 * tile_t - con_d) ])
            rotate([ 0, 90, 0 ]) children();
}
slot_con_x = -con_h / 2;
module bat_slot() difference() {
    translate([ -Ta(T24), 0, 0 ]) union() {
        for (i = [ -0.5, 0.5 ], j = [ -0.5, 0.5 ])
            translate([ 0, i * Ta(T24), j * Ta(T24) ])
                rotate([ j * 180 + 90, 0, 0 ]) mirror([ 1, 0, 0 ]) local_tile();
        translate([ -Ta(T24) / 4, 0, 0 ])
            cube([ Ta(T24) / 2, bat_t, Ta(T24) ], center = true);
        translate([ slot_con_x, 0, 0 ]) con_pos()
            cylinder(d = con_d + bat_t * 2, h = con_h, center = true);
    }
    translate([ -Ta(T24), 0, 0 ]) {
        translate([ slot_con_x, 0, 0 ]) con_pos()
            cylinder(d = con_d, h = con_h * 3, center = true);
        translate([ Ta(T24) / 4, 0, 0 ])
            cube([ Ta(T24) / 2, bat_t, Ta(T24) ], center = true);
    }
    for (i = [ -0.5, 0.5 ])
        translate([ 0, i * Ta(T24), 0 ]) rotate([ 0, 90, 0 ])
            cylinder(d = bat_d, h = bat_l, center = true);
}
holder_con_x = -con_h / 2;
zip_w = 6;
zip_h = 3;
zip_x = 4;
module bat_holder() difference() {
    union() {
        for (i = [ -0.5, 0.5 ])
            translate([ Ta(T24), i * Ta(T24), Ta(T24) / 2 - tile_t ])
                local_tile();
        translate([ Ta(T24) / 4, 0, 0 ])
            cube([ 2 * Ta(T24) + Ta(T24) / 2, bat_t, Ta(T24) ], center = true);
        translate([ holder_con_x, 0, 0 ]) con_pos()
            cylinder(d = con_d + bat_t * 2, h = con_h, center = true);
        translate([ Ta(T24) / 2, 0, 0 ])
            cube([ 2 * Ta(T24), Ta(T24), Ta(T24) / 2 ], center = true);
    }
    translate([ holder_con_x, 0, 0 ]) con_pos()
        cylinder(d = con_d, h = con_h * 3, center = true);

    for (i = [ -0.5, 0.5 ])
        translate([ 0, i * Ta(T24), 0 ]) rotate([ 0, 90, 0 ]) {
            cylinder(d = bat_d, h = bat_l, center = true);

            translate([ 0, 0, zip_x ])
                tube(d1 = bat_d + zip_h * 2, d2 = bat_d + zip_h * 4, h = zip_w);
        }
}

module bat_set() union() {
    finalize("orange") bat_holder();
    finalize("blue") bat_slot();

#
    for (i = [ -0.5, 0.5 ])
        translate([ 0, i * Ta(T24), 0 ]) rotate([ 0, 90, 0 ])
            bat(center = true);
}

//bat_set();
