include<LX15D.scad>;
include<tile.scad>;

t = 3;
tile_h = 5;
screw_d = 3;
hole_d = 10;

module femur_collision_a(tibiaOffset)
    translate([ 0, LX15D_horn_w / 2 + tile_h / 2, 0 ]) {
    hull() {
        cube([ Ta(T24), tile_h, Ta(T24) ], center = true);
        translate([ 0, 0, tibiaOffset[2] ])
            cube([ Ta(T24), tile_h, Ta(T24) ], center = true);
    }
    translate([ 0, 0, tibiaOffset[2] ]) hull() {
        cube([ Ta(T24), tile_h, Ta(T24) ], center = true);
        translate([ tibiaOffset[0], 0, 0 ])
            cube([ Ta(T24), tile_h, Ta(T24) ], center = true);
    }
}
module femur_collision_b(tibiaOffset) {
    mirror([ 0, 1, 0 ]) femur_collision_a(tibiaOffset);
}

module screw_pos(tibiaOffset) translate([ 0, LX15D_horn_w / 2, 0 ]) {
    rotate([ -90, 45, 0 ]) LX15D_horn_screw_pos() children();
    translate(tibiaOffset) rotate([ -90, 45, 0 ]) LX15D_horn_screw_pos()
        children();
}

module screw_center(tibiaOffset) translate([ 0, LX15D_horn_w / 2, 0 ]) {
    rotate([ -90, 0, 0 ]) children();
    translate(tibiaOffset) rotate([ -90, 0, 0 ]) children();
}

function middle_pos_f(tibiaOffset) = [ tibiaOffset[2], 0, tibiaOffset[2] ];
function v_len(v) = sqrt(pow(v[0], 2) + pow(v[1], 2) + pow(v[2], 2));

module middle_pos(tibiaOffset) {
    translate(middle_pos_f(tibiaOffset)) children();
}

module screw() { cylinder(d = screw_d + t * 2, h = tile_h); }

module femur_plate(tibiaOffset) {
    for (x = [0:Ta(T24):tibiaOffset[0] - 19])
        translate([ x, LX15D_horn_w / 2, tibiaOffset[2] ]) {
            rotate([ -90, 0, 0 ]) tile(T24, tile_h);
        }

    difference() {
        translate([ 0, LX15D_horn_w / 2, 0 ]) union() {
            hull() {
                translate([ 0, tile_h / 2, -Ta(T24) / 2 + tibiaOffset[2] ])
                    cube([ Ta(T24) * 3 / 4, tile_h, t ], center = true);
                rotate([ -90, 45, 0 ]) LX15D_horn_screw_pos() screw();
            }

            hull() {
                translate(tibiaOffset) rotate([ -90, 45, 0 ])
                    LX15D_horn_screw_pos() screw();
                translate(
                    [ tibiaOffset[0] - 19 / 2, tile_h / 2, tibiaOffset[2] ])
                    cube([ t, tile_h, 24 * 3 / 4 ], center = true);
            }
        }
        screw_pos(tibiaOffset) cylinder(d = screw_d, h = 100, center = true);
        screw_center(tibiaOffset)
            cylinder(d = LX15D_horn_clearance_d, h = 100, center = true);
    }
}

module femur(tibiaOffset, expand = 0) {
    for (m = [ 0, 1 ]) mirror([ 0, m, 0 ]) translate([ 0, 2 * expand, 0 ]) {
            translate([ 0, t + expand * 2, 0 ]) screw_pos(tibiaOffset)
                rotate([ 180, 0, 0 ]) Mscrew(M3L8C);
            finalize("purple") femur_plate(tibiaOffset);
        }
}
render_part = "femur_plate_a";
if (render_part == "femur_plate_a") {
    $fn = 128;
    femur_plate([ 95, 0, 30 ]);
} else if (render_part == "femur_plate_b") {
    $fn = 128;
    mirror([ 0, 1, 0 ]) femur_plate([ 95, 0, 30 ]);
}
