include <servo/horn.scad>;
include <base_plate/config.scad>;

include <strengthen/servo.scad>
use <servo/sg9.scad>;

module holder_top_base(){
    cylinder(d=mount_screw_d + t*2, h=plate_t);
}

module holder_hole()
{
    cylinder(d=mount_screw_d, h=1000, center=true);
}


// use as tibia in entire system
module tibia() {
    translate([-mg90s_turret_diameter/2, 0, 0])
    rotate([90, 0, -90])
        rotate([0, 0, 90]){
        	mg90s();
		translate([0, 11, -4.5])
		rotate([0, 0, 90])
		import("leg.stl");
        }

}


module femur(length){
    
    translate([-mg90s_turret_diameter/2 - servo_horn_h - mg90s_turret_height, 0, 0])
    rotate([0, -90, 0]){
        rotate([0, 0, 90])
            horn();
        translate([0, length, 0])
            rotate([0 ,0, -90])
                horn();
        translate([0, length/2, 3])
            rotate([0 ,0, -90])
                horn();
        translate([0, length/2, 3])
            rotate([0 ,0, 90])
                horn();
    }
}

module coxa(){

    translate([0, 0, -mount_h]){
        translate([0, 0, -mg90s_servo_height])
            rotate([0, 180, 90]){
                mg90s();
                rotate([0, 0, 0])
                    mirror([1, 0, 0])
                        servo_strengthen();
                translate([0, 0, mg90s_horn_offset]){
                horn();
                }
                
            }
        translate(mg90s_gimbal_vector)
        rotate([90, 0, -90])
            rotate([0, 0, 180]) {
                mg90s();
            }
    }
}
