
include <config.scad>;

module horn_hole(h=10, n=1) {
    cylinder(d=servo_horn_d, h=h, center=true);
    for(angle=[0:360/n:360])
        rotate([0, 0, angle])
        for(i=[0:servo_horn_holes_n])
            translate([i*servo_horn_holes_step + servo_horn_holes_first, 0, 0])
                cylinder(d=servo_horn_d2,h=h, center=true); 
}


module horn_mount(n=1){
    cylinder(d=servo_horn_d + t*2,h=plate_t);
    for(angle=[0:360/n:360])
        rotate([0, 0, angle])
           hull() for(i=[0:servo_horn_holes_n])
                translate([i*servo_horn_holes_step + servo_horn_holes_first, 0, 0])
                    cylinder(d=servo_horn_d2 + t*2,h=plate_t); 
}

module horn(n=1) difference(){

    rotate([180, 0, 0]){
        cylinder(d=servo_horn_d + servo_horn_t*2, h=servo_horn_h);    
        
        for(angle=[0:360/n:360])
            rotate([0, 0, angle])
                hull() for(i=[0:servo_horn_holes_n])
                translate([i*servo_horn_holes_step + servo_horn_holes_first, 0, 0])
                        cylinder(d=servo_horn_d2 + servo_horn_t*2,h=servo_horn_t); 
    }

    horn_hole(h=servo_horn_h*2, n=n);

}
 